/* Copyright 2011 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: AppState.h 340 2011-12-17 20:18:45Z tonic $
 * $Revision: 340 $
 */

#ifndef APPSTATE_H_INCL
#define APPSTATE_H_INCL


enum APPSTATE_ENUM
{
    APPSTATE_DEFAULT_FPS = 60
};


enum KEY_TYPE
{
    K_UP = 0,
    K_DOWN,
    K_LEFT,
    K_RIGHT,
    K_ACTION,
    K_FLAG_UP,
    K_FLAG_DOWN,
    K_FLAG_LEFT,
    K_FLAG_RIGHT,
    K_FLAG_ACTION,
    K_TYPE_COUNT //
};


class AppState
{
public:

    AppState() : mFPS(APPSTATE_DEFAULT_FPS),
                 mGameLogicTime(0), mStateTime(0), mPaused(false)
    {
        for (int a = 0; a < K_TYPE_COUNT; ++a)
            mKeyState[a] = false;
    }
    virtual ~AppState() {}

    virtual bool init() { return true; }
    virtual void deinit() {}

    I32 getUpdateFPS() { return mFPS; }

    virtual bool update(I32 deltaTime);
    virtual void render(irr::IrrlichtDevice *device) = 0;

    virtual void onActivate() { mGameLogicTime = mStateTime = 0; mPaused = false; }
    virtual void onDeactivate() {}

    virtual bool onKeyDown(const irr::SEvent::SKeyInput &event) { return false; }
    virtual bool onKeyUp(const irr::SEvent::SKeyInput &event) { return false; }
    virtual bool onMouseDown(const irr::SEvent::SMouseInput &event) { return false; }
    virtual bool onMouseUp(const irr::SEvent::SMouseInput &event) { return false; }
    virtual bool onMouseMotion(const irr::SEvent::SMouseInput &event) { return false; }
    virtual bool onMouseWheel(const irr::SEvent::SMouseInput &event) { return false; }

protected:

    I32 mFPS;
    I32 mGameLogicTime, mStateTime;
    bool mPaused;

    bool mKeyState[K_TYPE_COUNT];
};


#endif // !APPSTATE_H_INCL
